--pal.e
--Hollow Horse Software

include machine.e

global function get_palette(integer index)
    sequence regs
    integer red, green, blue
    if index < 0 then index = 0 end if
    if index > 255 then index = 255 end if
    regs = repeat(0,10)
    regs[REG_AX] = #1015
    regs[REG_BX] = index
    regs = dos_interrupt(#10,regs)
    green = and_bits(regs[REG_CX], #FF00) / 256
    blue  = and_bits(regs[REG_CX], #FF)
    red   = and_bits(regs[REG_DX], #FF00) / 256
    return {red, green, blue}
end function
-----------------------------------------------------------------------------
global procedure set_palette(integer index, sequence color)
    sequence regs
    regs = repeat(0, 10)
    regs[REG_AX] = #1010
    regs[REG_BX] = index
    regs[REG_CX] = color[2] * 256 + color[3]
    regs[REG_DX] = color[1] * 256
    regs = dos_interrupt(#10, regs)
end procedure    
-----------------------------------------------------------------------------

